Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/TranslocationInversionManipulatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/TranslocationInversionManipulatorTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/TranslocationInversionManipulatorTest.cs	(revision 2854)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for TranslocationInversionManipulator and is intended
+  ///to contain all TranslocationInversionManipulator Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class TranslocationInversionManipulatorTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void TranslocationInversionManipulatorApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent, expected;
+      // The following test is based on an example from Larranaga, P. et al. 1999. Genetic Algorithms for the Travelling Salesman Problem: A Review of Representations and Operators. Artificial Intelligence Review, 13
+      random.Reset();
+      random.IntNumbers = new int[] { 2, 4, 4 };
+      parent = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent.Validate());
+      
+      expected = new Permutation(new int[] { 0, 1, 5, 6, 4, 3, 2, 7 });
+      Assert.IsTrue(expected.Validate());
+      TranslocationInversionManipulator.Apply(random, parent);
+      Assert.IsTrue(parent.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, parent));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        CyclicCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for InversionManipulator Constructor
+    ///</summary>
+    [TestMethod()]
+    public void InversionManipulatorConstructorTest() {
+      TranslocationInversionManipulator target = new TranslocationInversionManipulator();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/Tests/TranslocationManipulatorTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/Tests/TranslocationManipulatorTest.cs	(revision 2854)
+++ trunk/sources/HeuristicLab.Permutation/3.3/Tests/TranslocationManipulatorTest.cs	(revision 2854)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Permutation;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Permutation.Tests {
+
+
+  /// <summary>
+  ///This is a test class for TranslocationManipulator and is intended
+  ///to contain all TranslocationManipulator Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class TranslocationManipulatorTest {
+
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for Apply
+    ///</summary>
+    [TestMethod()]
+    public void TranslocationManipulatorApplyTest() {
+      TestRandom random = new TestRandom();
+      Permutation parent, expected;
+      // The following test is based on an example from Larranaga, P. et al. 1999. Genetic Algorithms for the Travelling Salesman Problem: A Review of Representations and Operators. Artificial Intelligence Review, 13, p. 24
+      random.Reset();
+      random.IntNumbers = new int[] { 2, 4, 4 };
+      parent = new Permutation(new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
+      Assert.IsTrue(parent.Validate());
+      
+      expected = new Permutation(new int[] { 0, 1, 5, 6, 2, 3, 4, 7 });
+      Assert.IsTrue(expected.Validate());
+      TranslocationManipulator.Apply(random, parent);
+      Assert.IsTrue(parent.Validate());
+      Assert.IsTrue(Auxiliary.PermutationIsEqualByPosition(expected, parent));
+     
+      // perform a test when the two permutations are of unequal length
+      random.Reset();
+      bool exceptionFired = false;
+      try {
+        CyclicCrossover.Apply(random, new Permutation(8), new Permutation(6));
+      }
+      catch (System.ArgumentException) {
+        exceptionFired = true;
+      }
+      Assert.IsTrue(exceptionFired);
+    }
+
+    /// <summary>
+    ///A test for InversionManipulator Constructor
+    ///</summary>
+    [TestMethod()]
+    public void InversionManipulatorConstructorTest() {
+      TranslocationManipulator target = new TranslocationManipulator();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Permutation/3.3/TranslocationInversionManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/TranslocationInversionManipulator.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/TranslocationInversionManipulator.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,4 +24,6 @@
 using System.Text;
 using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
@@ -30,10 +32,12 @@
   /// (randomly chosen) position in the array.
   /// </summary>
-  public class TranslocationInversionManipulator : PermutationManipulatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  /// <remarks>
+  /// It is implemented as described in Fogel, D.B. (1993). Applying Evolutionary Programming to Selected TSP Problems, 
+  /// Cybernetics and Systems, 22, pp 27-36.<br />
+  /// </remarks>
+  [Item("TranslocationInversionManipulator", "An operator which inverts a randomly chosen part of a permutation and inserts it at a random position.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class TranslocationInversionManipulator : PermutationManipulator {
     /// <summary>
     /// Moves a randomly chosen interval of elements to another (randomly chosen) position in the given
@@ -42,12 +46,11 @@
     /// <param name="random">The random number generator.</param>
     /// <param name="permutation">The permutation array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    public static int[] Apply(IRandom random, int[] permutation) {
-      int[] result = (int[])permutation.Clone();
+    public static void Apply(IRandom random, Permutation permutation) {
+      Permutation original = (Permutation)permutation.Clone();
       int breakPoint1, breakPoint2, insertPoint, insertPointLimit;
 
-      breakPoint1 = random.Next(permutation.Length - 1);
-      breakPoint2 = random.Next(breakPoint1 + 1, permutation.Length);
-      insertPointLimit = permutation.Length - breakPoint2 + breakPoint1 - 1;  // get insertion point in remaining part
+      breakPoint1 = random.Next(original.Length - 1);
+      breakPoint2 = random.Next(breakPoint1 + 1, original.Length);
+      insertPointLimit = original.Length - breakPoint2 + breakPoint1 - 1;  // get insertion point in remaining part
       if (insertPointLimit > 0)
         insertPoint = random.Next(insertPointLimit);
@@ -57,8 +60,8 @@
       int i = 0;  // index in new permutation
       int j = 0;  // index in old permutation
-      while (i < permutation.Length) {
+      while (i < original.Length) {
         if (i == insertPoint) {  // copy translocated area
           for (int k = breakPoint2; k >= breakPoint1; k--) {
-            result[i] = permutation[k];
+            permutation[i] = original[k];
             i++;
           }
@@ -67,11 +70,10 @@
           j = breakPoint2 + 1;
         }
-        if ((i < permutation.Length) && (j < permutation.Length)) {
-          result[i] = permutation[j];
+        if ((i < original.Length) && (j < original.Length)) {
+          permutation[i] = original[j];
           i++;
           j++;
         }
       }
-      return result;
     }
 
@@ -81,10 +83,8 @@
     /// </summary>
     /// <remarks>Calls <see cref="Apply"/>.</remarks>
-    /// <param name="scope">The current scope.</param>
-    /// <param name="random">The random number generator.</param>
-    /// <param name="permutation">The permutation array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    protected override int[] Manipulate(IScope scope, IRandom random, int[] permutation) {
-      return Apply(random, permutation);
+    /// <param name="random">A random number generator.</param>
+    /// <param name="permutation">The permutation to manipulate.</param>
+    protected override void Manipulate(IRandom random, Permutation permutation) {
+      Apply(random, permutation);
     }
   }
Index: trunk/sources/HeuristicLab.Permutation/3.3/TranslocationManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Permutation/3.3/TranslocationManipulator.cs	(revision 2852)
+++ trunk/sources/HeuristicLab.Permutation/3.3/TranslocationManipulator.cs	(revision 2854)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,4 +24,5 @@
 using System.Text;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Permutation {
@@ -30,10 +31,11 @@
   /// (randomly chosen) position in the array.
   /// </summary>
-  public class TranslocationManipulator : PermutationManipulatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
-
+  /// <remarks>
+  /// It is implemented as described in Michalewicz, Z. (1992), Genetic Algorithms ü Data Structures = Evolution Programs, Springer Verlag, Berlin Heidelberg.<br />
+  /// </remarks>
+  [Item("TranslocationManipulator", "An operator which Manipulates a permutation array by moving a randomly chosen interval of elements to another (randomly chosen) position in the array.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public class TranslocationManipulator : PermutationManipulator {
     /// <summary>
     /// Moves a randomly chosen interval of elements to another (randomly chosen) position in the given
@@ -42,7 +44,6 @@
     /// <param name="random">The random number generator.</param>
     /// <param name="permutation">The permutation array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    public static int[] Apply(IRandom random, int[] permutation) {
-      int[] result = (int[])permutation.Clone();
+    public static void Apply(IRandom random, Permutation permutation) {
+      Permutation original = (Permutation)permutation.Clone();
       int breakPoint1, breakPoint2, insertPoint, insertPointLimit;
 
@@ -57,8 +58,8 @@
       int i = 0;  // index in new permutation
       int j = 0;  // index in old permutation
-      while (i < permutation.Length) {
+      while (i < original.Length) {
         if (i == insertPoint) {  // copy translocated area
           for (int k = breakPoint1; k <= breakPoint2; k++) {
-            result[i] = permutation[k];
+            permutation[i] = original[k];
             i++;
           }
@@ -67,11 +68,10 @@
           j = breakPoint2 + 1;
         }
-        if ((i < permutation.Length) && (j < permutation.Length)) {
-          result[i] = permutation[j];
+        if ((i < original.Length) && (j < original.Length)) {
+          permutation[i] = original[j];
           i++;
           j++;
         }
       }
-      return result;
     }
 
@@ -81,10 +81,8 @@
     /// </summary>
     /// <remarks>Calls <see cref="Apply"/>.</remarks>
-    /// <param name="scope">The current scope.</param>
-    /// <param name="random">The random number generator.</param>
-    /// <param name="permutation">The permutation array to manipulate.</param>
-    /// <returns>The new permuation array with the manipulated data.</returns>
-    protected override int[] Manipulate(IScope scope, IRandom random, int[] permutation) {
-      return Apply(random, permutation);
+    /// <param name="random">A random number generator.</param>
+    /// <param name="permutation">The permutation to manipulate.</param>
+    protected override void Manipulate(IRandom random, Permutation permutation) {
+      Apply(random, permutation);
     }
   }
